<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Adjust_Asset_Cost_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Adjust_Asset_Cost_ResponseType extends AbstractStructBase
{
    /**
     * The Submit_Business_Asset_Cost_Adjustment_Reference
     * Meta information extracted from the WSDL
     * - documentation: Business Asset specified for cost adjustment
     * - minOccurs: 0
     * @var \StructType\Business_AssetObjectType
     */
    public $Submit_Business_Asset_Cost_Adjustment_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Adjust_Asset_Cost_ResponseType
     * @uses Adjust_Asset_Cost_ResponseType::setSubmit_Business_Asset_Cost_Adjustment_Reference()
     * @uses Adjust_Asset_Cost_ResponseType::setVersion()
     * @param \StructType\Business_AssetObjectType $submit_Business_Asset_Cost_Adjustment_Reference
     * @param string $version
     */
    public function __construct(\StructType\Business_AssetObjectType $submit_Business_Asset_Cost_Adjustment_Reference = null, $version = null)
    {
        $this
            ->setSubmit_Business_Asset_Cost_Adjustment_Reference($submit_Business_Asset_Cost_Adjustment_Reference)
            ->setVersion($version);
    }
    /**
     * Get Submit_Business_Asset_Cost_Adjustment_Reference value
     * @return \StructType\Business_AssetObjectType|null
     */
    public function getSubmit_Business_Asset_Cost_Adjustment_Reference()
    {
        return $this->Submit_Business_Asset_Cost_Adjustment_Reference;
    }
    /**
     * Set Submit_Business_Asset_Cost_Adjustment_Reference value
     * @param \StructType\Business_AssetObjectType $submit_Business_Asset_Cost_Adjustment_Reference
     * @return \StructType\Adjust_Asset_Cost_ResponseType
     */
    public function setSubmit_Business_Asset_Cost_Adjustment_Reference(\StructType\Business_AssetObjectType $submit_Business_Asset_Cost_Adjustment_Reference = null)
    {
        $this->Submit_Business_Asset_Cost_Adjustment_Reference = $submit_Business_Asset_Cost_Adjustment_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Adjust_Asset_Cost_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
