<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cancel_Advanced_Ship_Notice_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Cancel an existing Advanced Ship Notice if it's eligible for Cancel
 * @subpackage Structs
 */
class Cancel_Advanced_Ship_Notice_RequestType extends AbstractStructBase
{
    /**
     * The Advanced_Ship_Notice_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Advanced Ship Notice.
     * - minOccurs: 0
     * @var \StructType\Advanced_Ship_NoticeObjectType
     */
    public $Advanced_Ship_Notice_Reference;
    /**
     * The Advanced_Ship_Notice_Data
     * Meta information extracted from the WSDL
     * - documentation: Advanced Ship Notice Data.
     * - minOccurs: 0
     * @var \StructType\Cancel_Advanced_Ship_Notice_DataType
     */
    public $Advanced_Ship_Notice_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Cancel_Advanced_Ship_Notice_RequestType
     * @uses Cancel_Advanced_Ship_Notice_RequestType::setAdvanced_Ship_Notice_Reference()
     * @uses Cancel_Advanced_Ship_Notice_RequestType::setAdvanced_Ship_Notice_Data()
     * @uses Cancel_Advanced_Ship_Notice_RequestType::setVersion()
     * @param \StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference
     * @param \StructType\Cancel_Advanced_Ship_Notice_DataType $advanced_Ship_Notice_Data
     * @param string $version
     */
    public function __construct(\StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference = null, \StructType\Cancel_Advanced_Ship_Notice_DataType $advanced_Ship_Notice_Data = null, $version = null)
    {
        $this
            ->setAdvanced_Ship_Notice_Reference($advanced_Ship_Notice_Reference)
            ->setAdvanced_Ship_Notice_Data($advanced_Ship_Notice_Data)
            ->setVersion($version);
    }
    /**
     * Get Advanced_Ship_Notice_Reference value
     * @return \StructType\Advanced_Ship_NoticeObjectType|null
     */
    public function getAdvanced_Ship_Notice_Reference()
    {
        return $this->Advanced_Ship_Notice_Reference;
    }
    /**
     * Set Advanced_Ship_Notice_Reference value
     * @param \StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference
     * @return \StructType\Cancel_Advanced_Ship_Notice_RequestType
     */
    public function setAdvanced_Ship_Notice_Reference(\StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference = null)
    {
        $this->Advanced_Ship_Notice_Reference = $advanced_Ship_Notice_Reference;
        return $this;
    }
    /**
     * Get Advanced_Ship_Notice_Data value
     * @return \StructType\Cancel_Advanced_Ship_Notice_DataType|null
     */
    public function getAdvanced_Ship_Notice_Data()
    {
        return $this->Advanced_Ship_Notice_Data;
    }
    /**
     * Set Advanced_Ship_Notice_Data value
     * @param \StructType\Cancel_Advanced_Ship_Notice_DataType $advanced_Ship_Notice_Data
     * @return \StructType\Cancel_Advanced_Ship_Notice_RequestType
     */
    public function setAdvanced_Ship_Notice_Data(\StructType\Cancel_Advanced_Ship_Notice_DataType $advanced_Ship_Notice_Data = null)
    {
        $this->Advanced_Ship_Notice_Data = $advanced_Ship_Notice_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Cancel_Advanced_Ship_Notice_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
