<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Primary_Image_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Primary Image for Item
 * @subpackage Structs
 */
class Primary_Image_DataType extends AbstractStructBase
{
    /**
     * The Image_Reference
     * Meta information extracted from the WSDL
     * - documentation: Image reference if it is an existing image
     * - minOccurs: 0
     * @var \StructType\ImageObjectType
     */
    public $Image_Reference;
    /**
     * The Image_Data
     * Meta information extracted from the WSDL
     * - documentation: Image Data associated with Image
     * - minOccurs: 0
     * @var \StructType\Image_DataType
     */
    public $Image_Data;
    /**
     * Constructor method for Primary_Image_DataType
     * @uses Primary_Image_DataType::setImage_Reference()
     * @uses Primary_Image_DataType::setImage_Data()
     * @param \StructType\ImageObjectType $image_Reference
     * @param \StructType\Image_DataType $image_Data
     */
    public function __construct(\StructType\ImageObjectType $image_Reference = null, \StructType\Image_DataType $image_Data = null)
    {
        $this
            ->setImage_Reference($image_Reference)
            ->setImage_Data($image_Data);
    }
    /**
     * Get Image_Reference value
     * @return \StructType\ImageObjectType|null
     */
    public function getImage_Reference()
    {
        return $this->Image_Reference;
    }
    /**
     * Set Image_Reference value
     * @param \StructType\ImageObjectType $image_Reference
     * @return \StructType\Primary_Image_DataType
     */
    public function setImage_Reference(\StructType\ImageObjectType $image_Reference = null)
    {
        $this->Image_Reference = $image_Reference;
        return $this;
    }
    /**
     * Get Image_Data value
     * @return \StructType\Image_DataType|null
     */
    public function getImage_Data()
    {
        return $this->Image_Data;
    }
    /**
     * Set Image_Data value
     * @param \StructType\Image_DataType $image_Data
     * @return \StructType\Primary_Image_DataType
     */
    public function setImage_Data(\StructType\Image_DataType $image_Data = null)
    {
        $this->Image_Data = $image_Data;
        return $this;
    }
}
