<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Procurement_Conditional_Rule_Request_ReferencesType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains Procurement Conditional Rule References
 * @subpackage Structs
 */
class Procurement_Conditional_Rule_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Procurement_Condition_Rule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Contains Procurement Conditional Rule References
     * - maxOccurs: unbounded
     * @var \StructType\Condition_RuleObjectType[]
     */
    public $Procurement_Condition_Rule_Reference;
    /**
     * Constructor method for Procurement_Conditional_Rule_Request_ReferencesType
     * @uses Procurement_Conditional_Rule_Request_ReferencesType::setProcurement_Condition_Rule_Reference()
     * @param \StructType\Condition_RuleObjectType[] $procurement_Condition_Rule_Reference
     */
    public function __construct(array $procurement_Condition_Rule_Reference = array())
    {
        $this
            ->setProcurement_Condition_Rule_Reference($procurement_Condition_Rule_Reference);
    }
    /**
     * Get Procurement_Condition_Rule_Reference value
     * @return \StructType\Condition_RuleObjectType[]|null
     */
    public function getProcurement_Condition_Rule_Reference()
    {
        return $this->Procurement_Condition_Rule_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProcurement_Condition_Rule_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProcurement_Condition_Rule_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProcurement_Condition_Rule_ReferenceForArrayConstraintsFromSetProcurement_Condition_Rule_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $procurement_Conditional_Rule_Request_ReferencesTypeProcurement_Condition_Rule_ReferenceItem) {
            // validation for constraint: itemType
            if (!$procurement_Conditional_Rule_Request_ReferencesTypeProcurement_Condition_Rule_ReferenceItem instanceof \StructType\Condition_RuleObjectType) {
                $invalidValues[] = is_object($procurement_Conditional_Rule_Request_ReferencesTypeProcurement_Condition_Rule_ReferenceItem) ? get_class($procurement_Conditional_Rule_Request_ReferencesTypeProcurement_Condition_Rule_ReferenceItem) : sprintf('%s(%s)', gettype($procurement_Conditional_Rule_Request_ReferencesTypeProcurement_Condition_Rule_ReferenceItem), var_export($procurement_Conditional_Rule_Request_ReferencesTypeProcurement_Condition_Rule_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Procurement_Condition_Rule_Reference property can only contain items of type \StructType\Condition_RuleObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Procurement_Condition_Rule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Condition_RuleObjectType[] $procurement_Condition_Rule_Reference
     * @return \StructType\Procurement_Conditional_Rule_Request_ReferencesType
     */
    public function setProcurement_Condition_Rule_Reference(array $procurement_Condition_Rule_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($procurement_Condition_Rule_ReferenceArrayErrorMessage = self::validateProcurement_Condition_Rule_ReferenceForArrayConstraintsFromSetProcurement_Condition_Rule_Reference($procurement_Condition_Rule_Reference))) {
            throw new \InvalidArgumentException($procurement_Condition_Rule_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Procurement_Condition_Rule_Reference = $procurement_Condition_Rule_Reference;
        return $this;
    }
    /**
     * Add item to Procurement_Condition_Rule_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Condition_RuleObjectType $item
     * @return \StructType\Procurement_Conditional_Rule_Request_ReferencesType
     */
    public function addToProcurement_Condition_Rule_Reference(\StructType\Condition_RuleObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Condition_RuleObjectType) {
            throw new \InvalidArgumentException(sprintf('The Procurement_Condition_Rule_Reference property can only contain items of type \StructType\Condition_RuleObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Procurement_Condition_Rule_Reference[] = $item;
        return $this;
    }
}
