<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Budget_Template_Response_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element that contains the Get Project Budget Templates response data.
 * @subpackage Structs
 */
class Project_Budget_Template_Response_DataType extends AbstractStructBase
{
    /**
     * The Project_Budget_Template
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Project_Budget_TemplateType[]
     */
    public $Project_Budget_Template;
    /**
     * Constructor method for Project_Budget_Template_Response_DataType
     * @uses Project_Budget_Template_Response_DataType::setProject_Budget_Template()
     * @param \StructType\Project_Budget_TemplateType[] $project_Budget_Template
     */
    public function __construct(array $project_Budget_Template = array())
    {
        $this
            ->setProject_Budget_Template($project_Budget_Template);
    }
    /**
     * Get Project_Budget_Template value
     * @return \StructType\Project_Budget_TemplateType[]|null
     */
    public function getProject_Budget_Template()
    {
        return $this->Project_Budget_Template;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Budget_Template method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Budget_Template method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Budget_TemplateForArrayConstraintsFromSetProject_Budget_Template(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Budget_Template_Response_DataTypeProject_Budget_TemplateItem) {
            // validation for constraint: itemType
            if (!$project_Budget_Template_Response_DataTypeProject_Budget_TemplateItem instanceof \StructType\Project_Budget_TemplateType) {
                $invalidValues[] = is_object($project_Budget_Template_Response_DataTypeProject_Budget_TemplateItem) ? get_class($project_Budget_Template_Response_DataTypeProject_Budget_TemplateItem) : sprintf('%s(%s)', gettype($project_Budget_Template_Response_DataTypeProject_Budget_TemplateItem), var_export($project_Budget_Template_Response_DataTypeProject_Budget_TemplateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Budget_Template property can only contain items of type \StructType\Project_Budget_TemplateType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Budget_Template value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_Budget_TemplateType[] $project_Budget_Template
     * @return \StructType\Project_Budget_Template_Response_DataType
     */
    public function setProject_Budget_Template(array $project_Budget_Template = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Budget_TemplateArrayErrorMessage = self::validateProject_Budget_TemplateForArrayConstraintsFromSetProject_Budget_Template($project_Budget_Template))) {
            throw new \InvalidArgumentException($project_Budget_TemplateArrayErrorMessage, __LINE__);
        }
        $this->Project_Budget_Template = $project_Budget_Template;
        return $this;
    }
    /**
     * Add item to Project_Budget_Template value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_Budget_TemplateType $item
     * @return \StructType\Project_Budget_Template_Response_DataType
     */
    public function addToProject_Budget_Template(\StructType\Project_Budget_TemplateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_Budget_TemplateType) {
            throw new \InvalidArgumentException(sprintf('The Project_Budget_Template property can only contain items of type \StructType\Project_Budget_TemplateType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Budget_Template[] = $item;
        return $this;
    }
}
