<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Hierarchy_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Project Hierarchy Request Reference Element.
 * @subpackage Structs
 */
class Project_Hierarchy_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Project_Hierarchy_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Hierarchy Request Reference Element.
     * - maxOccurs: unbounded
     * @var \StructType\Project_HierarchyObjectType[]
     */
    public $Project_Hierarchy_Reference;
    /**
     * Constructor method for Project_Hierarchy_Request_ReferencesType
     * @uses Project_Hierarchy_Request_ReferencesType::setProject_Hierarchy_Reference()
     * @param \StructType\Project_HierarchyObjectType[] $project_Hierarchy_Reference
     */
    public function __construct(array $project_Hierarchy_Reference = array())
    {
        $this
            ->setProject_Hierarchy_Reference($project_Hierarchy_Reference);
    }
    /**
     * Get Project_Hierarchy_Reference value
     * @return \StructType\Project_HierarchyObjectType[]|null
     */
    public function getProject_Hierarchy_Reference()
    {
        return $this->Project_Hierarchy_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Hierarchy_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Hierarchy_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Hierarchy_ReferenceForArrayConstraintsFromSetProject_Hierarchy_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Hierarchy_Request_ReferencesTypeProject_Hierarchy_ReferenceItem) {
            // validation for constraint: itemType
            if (!$project_Hierarchy_Request_ReferencesTypeProject_Hierarchy_ReferenceItem instanceof \StructType\Project_HierarchyObjectType) {
                $invalidValues[] = is_object($project_Hierarchy_Request_ReferencesTypeProject_Hierarchy_ReferenceItem) ? get_class($project_Hierarchy_Request_ReferencesTypeProject_Hierarchy_ReferenceItem) : sprintf('%s(%s)', gettype($project_Hierarchy_Request_ReferencesTypeProject_Hierarchy_ReferenceItem), var_export($project_Hierarchy_Request_ReferencesTypeProject_Hierarchy_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Hierarchy_Reference property can only contain items of type \StructType\Project_HierarchyObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Hierarchy_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_HierarchyObjectType[] $project_Hierarchy_Reference
     * @return \StructType\Project_Hierarchy_Request_ReferencesType
     */
    public function setProject_Hierarchy_Reference(array $project_Hierarchy_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Hierarchy_ReferenceArrayErrorMessage = self::validateProject_Hierarchy_ReferenceForArrayConstraintsFromSetProject_Hierarchy_Reference($project_Hierarchy_Reference))) {
            throw new \InvalidArgumentException($project_Hierarchy_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Project_Hierarchy_Reference = $project_Hierarchy_Reference;
        return $this;
    }
    /**
     * Add item to Project_Hierarchy_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_HierarchyObjectType $item
     * @return \StructType\Project_Hierarchy_Request_ReferencesType
     */
    public function addToProject_Hierarchy_Reference(\StructType\Project_HierarchyObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_HierarchyObjectType) {
            throw new \InvalidArgumentException(sprintf('The Project_Hierarchy_Reference property can only contain items of type \StructType\Project_HierarchyObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Hierarchy_Reference[] = $item;
        return $this;
    }
}
