<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_PlanType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing all project plan information requested.
 * @subpackage Structs
 */
class Project_PlanType extends AbstractStructBase
{
    /**
     * The Project_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Reference
     * - minOccurs: 0
     * @var \StructType\ProjectObjectType
     */
    public $Project_Reference;
    /**
     * The Project_Plan_Data
     * Meta information extracted from the WSDL
     * - documentation: This element contains project plan data
     * - minOccurs: 0
     * @var \StructType\Project_Plan_DataType
     */
    public $Project_Plan_Data;
    /**
     * Constructor method for Project_PlanType
     * @uses Project_PlanType::setProject_Reference()
     * @uses Project_PlanType::setProject_Plan_Data()
     * @param \StructType\ProjectObjectType $project_Reference
     * @param \StructType\Project_Plan_DataType $project_Plan_Data
     */
    public function __construct(\StructType\ProjectObjectType $project_Reference = null, \StructType\Project_Plan_DataType $project_Plan_Data = null)
    {
        $this
            ->setProject_Reference($project_Reference)
            ->setProject_Plan_Data($project_Plan_Data);
    }
    /**
     * Get Project_Reference value
     * @return \StructType\ProjectObjectType|null
     */
    public function getProject_Reference()
    {
        return $this->Project_Reference;
    }
    /**
     * Set Project_Reference value
     * @param \StructType\ProjectObjectType $project_Reference
     * @return \StructType\Project_PlanType
     */
    public function setProject_Reference(\StructType\ProjectObjectType $project_Reference = null)
    {
        $this->Project_Reference = $project_Reference;
        return $this;
    }
    /**
     * Get Project_Plan_Data value
     * @return \StructType\Project_Plan_DataType|null
     */
    public function getProject_Plan_Data()
    {
        return $this->Project_Plan_Data;
    }
    /**
     * Set Project_Plan_Data value
     * @param \StructType\Project_Plan_DataType $project_Plan_Data
     * @return \StructType\Project_PlanType
     */
    public function setProject_Plan_Data(\StructType\Project_Plan_DataType $project_Plan_Data = null)
    {
        $this->Project_Plan_Data = $project_Plan_Data;
        return $this;
    }
}
