<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Worker_Role_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing reference instances for a Project Worker Role
 * @subpackage Structs
 */
class Project_Worker_Role_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Project_Worker_Role_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Worker Role Reference
     * - maxOccurs: unbounded
     * @var \StructType\Project_RoleObjectType[]
     */
    public $Project_Worker_Role_Reference;
    /**
     * Constructor method for Project_Worker_Role_Request_ReferencesType
     * @uses Project_Worker_Role_Request_ReferencesType::setProject_Worker_Role_Reference()
     * @param \StructType\Project_RoleObjectType[] $project_Worker_Role_Reference
     */
    public function __construct(array $project_Worker_Role_Reference = array())
    {
        $this
            ->setProject_Worker_Role_Reference($project_Worker_Role_Reference);
    }
    /**
     * Get Project_Worker_Role_Reference value
     * @return \StructType\Project_RoleObjectType[]|null
     */
    public function getProject_Worker_Role_Reference()
    {
        return $this->Project_Worker_Role_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Worker_Role_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Worker_Role_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Worker_Role_ReferenceForArrayConstraintsFromSetProject_Worker_Role_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Worker_Role_Request_ReferencesTypeProject_Worker_Role_ReferenceItem) {
            // validation for constraint: itemType
            if (!$project_Worker_Role_Request_ReferencesTypeProject_Worker_Role_ReferenceItem instanceof \StructType\Project_RoleObjectType) {
                $invalidValues[] = is_object($project_Worker_Role_Request_ReferencesTypeProject_Worker_Role_ReferenceItem) ? get_class($project_Worker_Role_Request_ReferencesTypeProject_Worker_Role_ReferenceItem) : sprintf('%s(%s)', gettype($project_Worker_Role_Request_ReferencesTypeProject_Worker_Role_ReferenceItem), var_export($project_Worker_Role_Request_ReferencesTypeProject_Worker_Role_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Worker_Role_Reference property can only contain items of type \StructType\Project_RoleObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Worker_Role_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_RoleObjectType[] $project_Worker_Role_Reference
     * @return \StructType\Project_Worker_Role_Request_ReferencesType
     */
    public function setProject_Worker_Role_Reference(array $project_Worker_Role_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Worker_Role_ReferenceArrayErrorMessage = self::validateProject_Worker_Role_ReferenceForArrayConstraintsFromSetProject_Worker_Role_Reference($project_Worker_Role_Reference))) {
            throw new \InvalidArgumentException($project_Worker_Role_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Project_Worker_Role_Reference = $project_Worker_Role_Reference;
        return $this;
    }
    /**
     * Add item to Project_Worker_Role_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_RoleObjectType $item
     * @return \StructType\Project_Worker_Role_Request_ReferencesType
     */
    public function addToProject_Worker_Role_Reference(\StructType\Project_RoleObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_RoleObjectType) {
            throw new \InvalidArgumentException(sprintf('The Project_Worker_Role_Reference property can only contain items of type \StructType\Project_RoleObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Worker_Role_Reference[] = $item;
        return $this;
    }
}
