<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Commodity_Code_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Commodity Code Response Element
 * @subpackage Structs
 */
class Put_Commodity_Code_ResponseType extends AbstractStructBase
{
    /**
     * The Commodity_Code_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Commodity Code that was created\updated via this inbound Web Service operation.
     * - minOccurs: 0
     * @var \StructType\Commodity_CodeObjectType
     */
    public $Commodity_Code_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Commodity_Code_ResponseType
     * @uses Put_Commodity_Code_ResponseType::setCommodity_Code_Reference()
     * @uses Put_Commodity_Code_ResponseType::setVersion()
     * @param \StructType\Commodity_CodeObjectType $commodity_Code_Reference
     * @param string $version
     */
    public function __construct(\StructType\Commodity_CodeObjectType $commodity_Code_Reference = null, $version = null)
    {
        $this
            ->setCommodity_Code_Reference($commodity_Code_Reference)
            ->setVersion($version);
    }
    /**
     * Get Commodity_Code_Reference value
     * @return \StructType\Commodity_CodeObjectType|null
     */
    public function getCommodity_Code_Reference()
    {
        return $this->Commodity_Code_Reference;
    }
    /**
     * Set Commodity_Code_Reference value
     * @param \StructType\Commodity_CodeObjectType $commodity_Code_Reference
     * @return \StructType\Put_Commodity_Code_ResponseType
     */
    public function setCommodity_Code_Reference(\StructType\Commodity_CodeObjectType $commodity_Code_Reference = null)
    {
        $this->Commodity_Code_Reference = $commodity_Code_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Commodity_Code_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
