<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Project_Budget_Template_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Response Element for adding or modifying a Project Budget Template.
 * @subpackage Structs
 */
class Put_Project_Budget_Template_ResponseType extends AbstractStructBase
{
    /**
     * The Project_Budget_Template_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Project Budget Template that was added or modified.
     * - minOccurs: 0
     * @var \StructType\Project_Budget_TemplateObjectType
     */
    public $Project_Budget_Template_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Project_Budget_Template_ResponseType
     * @uses Put_Project_Budget_Template_ResponseType::setProject_Budget_Template_Reference()
     * @uses Put_Project_Budget_Template_ResponseType::setVersion()
     * @param \StructType\Project_Budget_TemplateObjectType $project_Budget_Template_Reference
     * @param string $version
     */
    public function __construct(\StructType\Project_Budget_TemplateObjectType $project_Budget_Template_Reference = null, $version = null)
    {
        $this
            ->setProject_Budget_Template_Reference($project_Budget_Template_Reference)
            ->setVersion($version);
    }
    /**
     * Get Project_Budget_Template_Reference value
     * @return \StructType\Project_Budget_TemplateObjectType|null
     */
    public function getProject_Budget_Template_Reference()
    {
        return $this->Project_Budget_Template_Reference;
    }
    /**
     * Set Project_Budget_Template_Reference value
     * @param \StructType\Project_Budget_TemplateObjectType $project_Budget_Template_Reference
     * @return \StructType\Put_Project_Budget_Template_ResponseType
     */
    public function setProject_Budget_Template_Reference(\StructType\Project_Budget_TemplateObjectType $project_Budget_Template_Reference = null)
    {
        $this->Project_Budget_Template_Reference = $project_Budget_Template_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Project_Budget_Template_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
