<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Project_Phase_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Response after Putting a Project Phase.
 * @subpackage Structs
 */
class Put_Project_Phase_ResponseType extends AbstractStructBase
{
    /**
     * The Project_Phase_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Phase Reference
     * - minOccurs: 0
     * @var \StructType\Project_PhaseObjectType
     */
    public $Project_Phase_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Project_Phase_ResponseType
     * @uses Put_Project_Phase_ResponseType::setProject_Phase_Reference()
     * @uses Put_Project_Phase_ResponseType::setVersion()
     * @param \StructType\Project_PhaseObjectType $project_Phase_Reference
     * @param string $version
     */
    public function __construct(\StructType\Project_PhaseObjectType $project_Phase_Reference = null, $version = null)
    {
        $this
            ->setProject_Phase_Reference($project_Phase_Reference)
            ->setVersion($version);
    }
    /**
     * Get Project_Phase_Reference value
     * @return \StructType\Project_PhaseObjectType|null
     */
    public function getProject_Phase_Reference()
    {
        return $this->Project_Phase_Reference;
    }
    /**
     * Set Project_Phase_Reference value
     * @param \StructType\Project_PhaseObjectType $project_Phase_Reference
     * @return \StructType\Put_Project_Phase_ResponseType
     */
    public function setProject_Phase_Reference(\StructType\Project_PhaseObjectType $project_Phase_Reference = null)
    {
        $this->Project_Phase_Reference = $project_Phase_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Project_Phase_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
