<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Purchase_Item_Group_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Put Purchase Item Group Response Data
 * @subpackage Structs
 */
class Put_Purchase_Item_Group_ResponseType extends AbstractStructBase
{
    /**
     * The Purchase_Item_Group_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Purchase Item Group
     * - minOccurs: 0
     * @var \StructType\Purchase_Item_GroupObjectType
     */
    public $Purchase_Item_Group_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Purchase_Item_Group_ResponseType
     * @uses Put_Purchase_Item_Group_ResponseType::setPurchase_Item_Group_Reference()
     * @uses Put_Purchase_Item_Group_ResponseType::setVersion()
     * @param \StructType\Purchase_Item_GroupObjectType $purchase_Item_Group_Reference
     * @param string $version
     */
    public function __construct(\StructType\Purchase_Item_GroupObjectType $purchase_Item_Group_Reference = null, $version = null)
    {
        $this
            ->setPurchase_Item_Group_Reference($purchase_Item_Group_Reference)
            ->setVersion($version);
    }
    /**
     * Get Purchase_Item_Group_Reference value
     * @return \StructType\Purchase_Item_GroupObjectType|null
     */
    public function getPurchase_Item_Group_Reference()
    {
        return $this->Purchase_Item_Group_Reference;
    }
    /**
     * Set Purchase_Item_Group_Reference value
     * @param \StructType\Purchase_Item_GroupObjectType $purchase_Item_Group_Reference
     * @return \StructType\Put_Purchase_Item_Group_ResponseType
     */
    public function setPurchase_Item_Group_Reference(\StructType\Purchase_Item_GroupObjectType $purchase_Item_Group_Reference = null)
    {
        $this->Purchase_Item_Group_Reference = $purchase_Item_Group_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Purchase_Item_Group_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
