<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Purchase_Item_List_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Restricted Purchase Item List Response
 * @subpackage Structs
 */
class Put_Purchase_Item_List_ResponseType extends AbstractStructBase
{
    /**
     * The Purchase_Item_List_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Restricted Purchase Item List.
     * - minOccurs: 0
     * @var \StructType\Restricted_Purchase_Item_ListObjectType
     */
    public $Purchase_Item_List_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Purchase_Item_List_ResponseType
     * @uses Put_Purchase_Item_List_ResponseType::setPurchase_Item_List_Reference()
     * @uses Put_Purchase_Item_List_ResponseType::setVersion()
     * @param \StructType\Restricted_Purchase_Item_ListObjectType $purchase_Item_List_Reference
     * @param string $version
     */
    public function __construct(\StructType\Restricted_Purchase_Item_ListObjectType $purchase_Item_List_Reference = null, $version = null)
    {
        $this
            ->setPurchase_Item_List_Reference($purchase_Item_List_Reference)
            ->setVersion($version);
    }
    /**
     * Get Purchase_Item_List_Reference value
     * @return \StructType\Restricted_Purchase_Item_ListObjectType|null
     */
    public function getPurchase_Item_List_Reference()
    {
        return $this->Purchase_Item_List_Reference;
    }
    /**
     * Set Purchase_Item_List_Reference value
     * @param \StructType\Restricted_Purchase_Item_ListObjectType $purchase_Item_List_Reference
     * @return \StructType\Put_Purchase_Item_List_ResponseType
     */
    public function setPurchase_Item_List_Reference(\StructType\Restricted_Purchase_Item_ListObjectType $purchase_Item_List_Reference = null)
    {
        $this->Purchase_Item_List_Reference = $purchase_Item_List_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Purchase_Item_List_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
