<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Supplier_Contract_Document_Link_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Response Element to hold Supplier Contract Reference
 * @subpackage Structs
 */
class Put_Supplier_Contract_Document_Link_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Contract_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier Contract Reference
     * - minOccurs: 0
     * @var \StructType\Supplier_ContractObjectType
     */
    public $Supplier_Contract_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Supplier_Contract_Document_Link_ResponseType
     * @uses Put_Supplier_Contract_Document_Link_ResponseType::setSupplier_Contract_Reference()
     * @uses Put_Supplier_Contract_Document_Link_ResponseType::setVersion()
     * @param \StructType\Supplier_ContractObjectType $supplier_Contract_Reference
     * @param string $version
     */
    public function __construct(\StructType\Supplier_ContractObjectType $supplier_Contract_Reference = null, $version = null)
    {
        $this
            ->setSupplier_Contract_Reference($supplier_Contract_Reference)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Contract_Reference value
     * @return \StructType\Supplier_ContractObjectType|null
     */
    public function getSupplier_Contract_Reference()
    {
        return $this->Supplier_Contract_Reference;
    }
    /**
     * Set Supplier_Contract_Reference value
     * @param \StructType\Supplier_ContractObjectType $supplier_Contract_Reference
     * @return \StructType\Put_Supplier_Contract_Document_Link_ResponseType
     */
    public function setSupplier_Contract_Reference(\StructType\Supplier_ContractObjectType $supplier_Contract_Reference = null)
    {
        $this->Supplier_Contract_Reference = $supplier_Contract_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Contract_Document_Link_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
