<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Supplier_Invoice_Links_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Supplier Invoice reference for update and all Supplier Invoice data items
 * @subpackage Structs
 */
class Put_Supplier_Invoice_Links_RequestType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier Invoice Document
     * @var \StructType\Supplier_Invoice_DocumentObjectType
     */
    public $Supplier_Invoice_Reference;
    /**
     * The Supplier_Invoice_Document_Link_Data
     * Meta information extracted from the WSDL
     * - documentation: Supplier Invoice Document Link Data
     * @var \StructType\Supplier_Invoice_Document_Link_DataType
     */
    public $Supplier_Invoice_Document_Link_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Supplier_Invoice_Links_RequestType
     * @uses Put_Supplier_Invoice_Links_RequestType::setSupplier_Invoice_Reference()
     * @uses Put_Supplier_Invoice_Links_RequestType::setSupplier_Invoice_Document_Link_Data()
     * @uses Put_Supplier_Invoice_Links_RequestType::setVersion()
     * @param \StructType\Supplier_Invoice_DocumentObjectType $supplier_Invoice_Reference
     * @param \StructType\Supplier_Invoice_Document_Link_DataType $supplier_Invoice_Document_Link_Data
     * @param string $version
     */
    public function __construct(\StructType\Supplier_Invoice_DocumentObjectType $supplier_Invoice_Reference = null, \StructType\Supplier_Invoice_Document_Link_DataType $supplier_Invoice_Document_Link_Data = null, $version = null)
    {
        $this
            ->setSupplier_Invoice_Reference($supplier_Invoice_Reference)
            ->setSupplier_Invoice_Document_Link_Data($supplier_Invoice_Document_Link_Data)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Invoice_Reference value
     * @return \StructType\Supplier_Invoice_DocumentObjectType|null
     */
    public function getSupplier_Invoice_Reference()
    {
        return $this->Supplier_Invoice_Reference;
    }
    /**
     * Set Supplier_Invoice_Reference value
     * @param \StructType\Supplier_Invoice_DocumentObjectType $supplier_Invoice_Reference
     * @return \StructType\Put_Supplier_Invoice_Links_RequestType
     */
    public function setSupplier_Invoice_Reference(\StructType\Supplier_Invoice_DocumentObjectType $supplier_Invoice_Reference = null)
    {
        $this->Supplier_Invoice_Reference = $supplier_Invoice_Reference;
        return $this;
    }
    /**
     * Get Supplier_Invoice_Document_Link_Data value
     * @return \StructType\Supplier_Invoice_Document_Link_DataType|null
     */
    public function getSupplier_Invoice_Document_Link_Data()
    {
        return $this->Supplier_Invoice_Document_Link_Data;
    }
    /**
     * Set Supplier_Invoice_Document_Link_Data value
     * @param \StructType\Supplier_Invoice_Document_Link_DataType $supplier_Invoice_Document_Link_Data
     * @return \StructType\Put_Supplier_Invoice_Links_RequestType
     */
    public function setSupplier_Invoice_Document_Link_Data(\StructType\Supplier_Invoice_Document_Link_DataType $supplier_Invoice_Document_Link_Data = null)
    {
        $this->Supplier_Invoice_Document_Link_Data = $supplier_Invoice_Document_Link_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Invoice_Links_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
