<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Worktag_Split_Template_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Request for Worktag Split Template
 * @subpackage Structs
 */
class Put_Worktag_Split_Template_RequestType extends AbstractStructBase
{
    /**
     * The Worktag_Split_Template_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference for Worktag Split Template
     * - minOccurs: 0
     * @var \StructType\Worktag_Split_TemplateObjectType
     */
    public $Worktag_Split_Template_Reference;
    /**
     * The Worktag_Split_Template_Data
     * Meta information extracted from the WSDL
     * - documentation: Data for Worktag Split Template
     * @var \StructType\Worktag_Split_Template_DataType
     */
    public $Worktag_Split_Template_Data;
    /**
     * The Add_Only
     * Meta information extracted from the WSDL
     * - documentation: Add Only Flag. Indicates that the service is an add only, not an update.
     * @var bool
     */
    public $Add_Only;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Worktag_Split_Template_RequestType
     * @uses Put_Worktag_Split_Template_RequestType::setWorktag_Split_Template_Reference()
     * @uses Put_Worktag_Split_Template_RequestType::setWorktag_Split_Template_Data()
     * @uses Put_Worktag_Split_Template_RequestType::setAdd_Only()
     * @uses Put_Worktag_Split_Template_RequestType::setVersion()
     * @param \StructType\Worktag_Split_TemplateObjectType $worktag_Split_Template_Reference
     * @param \StructType\Worktag_Split_Template_DataType $worktag_Split_Template_Data
     * @param bool $add_Only
     * @param string $version
     */
    public function __construct(\StructType\Worktag_Split_TemplateObjectType $worktag_Split_Template_Reference = null, \StructType\Worktag_Split_Template_DataType $worktag_Split_Template_Data = null, $add_Only = null, $version = null)
    {
        $this
            ->setWorktag_Split_Template_Reference($worktag_Split_Template_Reference)
            ->setWorktag_Split_Template_Data($worktag_Split_Template_Data)
            ->setAdd_Only($add_Only)
            ->setVersion($version);
    }
    /**
     * Get Worktag_Split_Template_Reference value
     * @return \StructType\Worktag_Split_TemplateObjectType|null
     */
    public function getWorktag_Split_Template_Reference()
    {
        return $this->Worktag_Split_Template_Reference;
    }
    /**
     * Set Worktag_Split_Template_Reference value
     * @param \StructType\Worktag_Split_TemplateObjectType $worktag_Split_Template_Reference
     * @return \StructType\Put_Worktag_Split_Template_RequestType
     */
    public function setWorktag_Split_Template_Reference(\StructType\Worktag_Split_TemplateObjectType $worktag_Split_Template_Reference = null)
    {
        $this->Worktag_Split_Template_Reference = $worktag_Split_Template_Reference;
        return $this;
    }
    /**
     * Get Worktag_Split_Template_Data value
     * @return \StructType\Worktag_Split_Template_DataType|null
     */
    public function getWorktag_Split_Template_Data()
    {
        return $this->Worktag_Split_Template_Data;
    }
    /**
     * Set Worktag_Split_Template_Data value
     * @param \StructType\Worktag_Split_Template_DataType $worktag_Split_Template_Data
     * @return \StructType\Put_Worktag_Split_Template_RequestType
     */
    public function setWorktag_Split_Template_Data(\StructType\Worktag_Split_Template_DataType $worktag_Split_Template_Data = null)
    {
        $this->Worktag_Split_Template_Data = $worktag_Split_Template_Data;
        return $this;
    }
    /**
     * Get Add_Only value
     * @return bool|null
     */
    public function getAdd_Only()
    {
        return $this->Add_Only;
    }
    /**
     * Set Add_Only value
     * @param bool $add_Only
     * @return \StructType\Put_Worktag_Split_Template_RequestType
     */
    public function setAdd_Only($add_Only = null)
    {
        // validation for constraint: boolean
        if (!is_null($add_Only) && !is_bool($add_Only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($add_Only, true), gettype($add_Only)), __LINE__);
        }
        $this->Add_Only = $add_Only;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Worktag_Split_Template_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
