<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Remove_Asset_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Remove Asset operation.
 * @subpackage Structs
 */
class Remove_Asset_ResponseType extends AbstractStructBase
{
    /**
     * The Asset_Removal_Event__CL__Reference
     * Meta information extracted from the WSDL
     * - documentation: A reference to the Asset Removal Event that was created by the request.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Asset_Removal_Event__CL__Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Remove_Asset_ResponseType
     * @uses Remove_Asset_ResponseType::setAsset_Removal_Event__CL__Reference()
     * @uses Remove_Asset_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $asset_Removal_Event__CL__Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $asset_Removal_Event__CL__Reference = null, $version = null)
    {
        $this
            ->setAsset_Removal_Event__CL__Reference($asset_Removal_Event__CL__Reference)
            ->setVersion($version);
    }
    /**
     * Get Asset_Removal_Event__CL__Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getAsset_Removal_Event__CL__Reference()
    {
        return $this->Asset_Removal_Event__CL__Reference;
    }
    /**
     * Set Asset_Removal_Event__CL__Reference value
     * @param \StructType\Unique_IdentifierObjectType $asset_Removal_Event__CL__Reference
     * @return \StructType\Remove_Asset_ResponseType
     */
    public function setAsset_Removal_Event__CL__Reference(\StructType\Unique_IdentifierObjectType $asset_Removal_Event__CL__Reference = null)
    {
        $this->Asset_Removal_Event__CL__Reference = $asset_Removal_Event__CL__Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Remove_Asset_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
