<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Supplier_Contract_Amendment_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Supplier Contract Amendment Response
 * @subpackage Structs
 */
class Submit_Supplier_Contract_Amendment_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Contract_Amendment_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier Contract Amendment Reference
     * - minOccurs: 0
     * @var \StructType\Supplier_Contract_AmendmentObjectType
     */
    public $Supplier_Contract_Amendment_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Supplier_Contract_Amendment_ResponseType
     * @uses Submit_Supplier_Contract_Amendment_ResponseType::setSupplier_Contract_Amendment_Reference()
     * @uses Submit_Supplier_Contract_Amendment_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Supplier_Contract_Amendment_ResponseType::setVersion()
     * @param \StructType\Supplier_Contract_AmendmentObjectType $supplier_Contract_Amendment_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\Supplier_Contract_AmendmentObjectType $supplier_Contract_Amendment_Reference = null, \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null, $version = null)
    {
        $this
            ->setSupplier_Contract_Amendment_Reference($supplier_Contract_Amendment_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Contract_Amendment_Reference value
     * @return \StructType\Supplier_Contract_AmendmentObjectType|null
     */
    public function getSupplier_Contract_Amendment_Reference()
    {
        return $this->Supplier_Contract_Amendment_Reference;
    }
    /**
     * Set Supplier_Contract_Amendment_Reference value
     * @param \StructType\Supplier_Contract_AmendmentObjectType $supplier_Contract_Amendment_Reference
     * @return \StructType\Submit_Supplier_Contract_Amendment_ResponseType
     */
    public function setSupplier_Contract_Amendment_Reference(\StructType\Supplier_Contract_AmendmentObjectType $supplier_Contract_Amendment_Reference = null)
    {
        $this->Supplier_Contract_Amendment_Reference = $supplier_Contract_Amendment_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * Set Exceptions_Response_Data value
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @return \StructType\Submit_Supplier_Contract_Amendment_ResponseType
     */
    public function setExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null)
    {
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Supplier_Contract_Amendment_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
