<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupplierType StructType
 * Meta information extracted from the WSDL
 * - documentation: This element is the wrapper element for all Supplier data
 * @subpackage Structs
 */
class SupplierType extends AbstractStructBase
{
    /**
     * The Supplier_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier Reference
     * - minOccurs: 0
     * @var \StructType\SupplierObjectType
     */
    public $Supplier_Reference;
    /**
     * The Supplier_Data
     * Meta information extracted from the WSDL
     * - documentation: This Element contains Supplier attributes.
     * - minOccurs: 0
     * @var \StructType\Supplier_DataType
     */
    public $Supplier_Data;
    /**
     * Constructor method for SupplierType
     * @uses SupplierType::setSupplier_Reference()
     * @uses SupplierType::setSupplier_Data()
     * @param \StructType\SupplierObjectType $supplier_Reference
     * @param \StructType\Supplier_DataType $supplier_Data
     */
    public function __construct(\StructType\SupplierObjectType $supplier_Reference = null, \StructType\Supplier_DataType $supplier_Data = null)
    {
        $this
            ->setSupplier_Reference($supplier_Reference)
            ->setSupplier_Data($supplier_Data);
    }
    /**
     * Get Supplier_Reference value
     * @return \StructType\SupplierObjectType|null
     */
    public function getSupplier_Reference()
    {
        return $this->Supplier_Reference;
    }
    /**
     * Set Supplier_Reference value
     * @param \StructType\SupplierObjectType $supplier_Reference
     * @return \StructType\SupplierType
     */
    public function setSupplier_Reference(\StructType\SupplierObjectType $supplier_Reference = null)
    {
        $this->Supplier_Reference = $supplier_Reference;
        return $this;
    }
    /**
     * Get Supplier_Data value
     * @return \StructType\Supplier_DataType|null
     */
    public function getSupplier_Data()
    {
        return $this->Supplier_Data;
    }
    /**
     * Set Supplier_Data value
     * @param \StructType\Supplier_DataType $supplier_Data
     * @return \StructType\SupplierType
     */
    public function setSupplier_Data(\StructType\Supplier_DataType $supplier_Data = null)
    {
        $this->Supplier_Data = $supplier_Data;
        return $this;
    }
}
