<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: This element contains the specific instance set containing the requested supplier invoice work queue tag.
 * @subpackage Structs
 */
class Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Work_Queue_Tag_Reference
     * Meta information extracted from the WSDL
     * - documentation: The supplier invoice work queue tag
     * - maxOccurs: unbounded
     * @var \StructType\Supplier_Invoice_Work_Queue_TagObjectType[]
     */
    public $Supplier_Invoice_Work_Queue_Tag_Reference;
    /**
     * Constructor method for Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType
     * @uses Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType::setSupplier_Invoice_Work_Queue_Tag_Reference()
     * @param \StructType\Supplier_Invoice_Work_Queue_TagObjectType[] $supplier_Invoice_Work_Queue_Tag_Reference
     */
    public function __construct(array $supplier_Invoice_Work_Queue_Tag_Reference = array())
    {
        $this
            ->setSupplier_Invoice_Work_Queue_Tag_Reference($supplier_Invoice_Work_Queue_Tag_Reference);
    }
    /**
     * Get Supplier_Invoice_Work_Queue_Tag_Reference value
     * @return \StructType\Supplier_Invoice_Work_Queue_TagObjectType[]|null
     */
    public function getSupplier_Invoice_Work_Queue_Tag_Reference()
    {
        return $this->Supplier_Invoice_Work_Queue_Tag_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplier_Invoice_Work_Queue_Tag_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplier_Invoice_Work_Queue_Tag_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplier_Invoice_Work_Queue_Tag_ReferenceForArrayConstraintsFromSetSupplier_Invoice_Work_Queue_Tag_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $supplier_Invoice_Work_Queue_Tag_Request_ReferencesTypeSupplier_Invoice_Work_Queue_Tag_ReferenceItem) {
            // validation for constraint: itemType
            if (!$supplier_Invoice_Work_Queue_Tag_Request_ReferencesTypeSupplier_Invoice_Work_Queue_Tag_ReferenceItem instanceof \StructType\Supplier_Invoice_Work_Queue_TagObjectType) {
                $invalidValues[] = is_object($supplier_Invoice_Work_Queue_Tag_Request_ReferencesTypeSupplier_Invoice_Work_Queue_Tag_ReferenceItem) ? get_class($supplier_Invoice_Work_Queue_Tag_Request_ReferencesTypeSupplier_Invoice_Work_Queue_Tag_ReferenceItem) : sprintf('%s(%s)', gettype($supplier_Invoice_Work_Queue_Tag_Request_ReferencesTypeSupplier_Invoice_Work_Queue_Tag_ReferenceItem), var_export($supplier_Invoice_Work_Queue_Tag_Request_ReferencesTypeSupplier_Invoice_Work_Queue_Tag_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Supplier_Invoice_Work_Queue_Tag_Reference property can only contain items of type \StructType\Supplier_Invoice_Work_Queue_TagObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Supplier_Invoice_Work_Queue_Tag_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_Work_Queue_TagObjectType[] $supplier_Invoice_Work_Queue_Tag_Reference
     * @return \StructType\Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType
     */
    public function setSupplier_Invoice_Work_Queue_Tag_Reference(array $supplier_Invoice_Work_Queue_Tag_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($supplier_Invoice_Work_Queue_Tag_ReferenceArrayErrorMessage = self::validateSupplier_Invoice_Work_Queue_Tag_ReferenceForArrayConstraintsFromSetSupplier_Invoice_Work_Queue_Tag_Reference($supplier_Invoice_Work_Queue_Tag_Reference))) {
            throw new \InvalidArgumentException($supplier_Invoice_Work_Queue_Tag_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Supplier_Invoice_Work_Queue_Tag_Reference = $supplier_Invoice_Work_Queue_Tag_Reference;
        return $this;
    }
    /**
     * Add item to Supplier_Invoice_Work_Queue_Tag_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_Work_Queue_TagObjectType $item
     * @return \StructType\Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType
     */
    public function addToSupplier_Invoice_Work_Queue_Tag_Reference(\StructType\Supplier_Invoice_Work_Queue_TagObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Supplier_Invoice_Work_Queue_TagObjectType) {
            throw new \InvalidArgumentException(sprintf('The Supplier_Invoice_Work_Queue_Tag_Reference property can only contain items of type \StructType\Supplier_Invoice_Work_Queue_TagObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Supplier_Invoice_Work_Queue_Tag_Reference[] = $item;
        return $this;
    }
}
