<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Order_ContractType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing supplier contract reference and data
 * @subpackage Structs
 */
class Supplier_Order_ContractType extends AbstractStructBase
{
    /**
     * The Supplier_Order_Contract_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier Order Contract Reference
     * - minOccurs: 0
     * @var \StructType\Supplier_ContractObjectType
     */
    public $Supplier_Order_Contract_Reference;
    /**
     * The Supplier_Order_Contract_Data
     * Meta information extracted from the WSDL
     * - documentation: Supplier Order Contract Data
     * - minOccurs: 0
     * @var \StructType\Supplier_Order_Contract_Data_for_Put_and_GetType
     */
    public $Supplier_Order_Contract_Data;
    /**
     * Constructor method for Supplier_Order_ContractType
     * @uses Supplier_Order_ContractType::setSupplier_Order_Contract_Reference()
     * @uses Supplier_Order_ContractType::setSupplier_Order_Contract_Data()
     * @param \StructType\Supplier_ContractObjectType $supplier_Order_Contract_Reference
     * @param \StructType\Supplier_Order_Contract_Data_for_Put_and_GetType $supplier_Order_Contract_Data
     */
    public function __construct(\StructType\Supplier_ContractObjectType $supplier_Order_Contract_Reference = null, \StructType\Supplier_Order_Contract_Data_for_Put_and_GetType $supplier_Order_Contract_Data = null)
    {
        $this
            ->setSupplier_Order_Contract_Reference($supplier_Order_Contract_Reference)
            ->setSupplier_Order_Contract_Data($supplier_Order_Contract_Data);
    }
    /**
     * Get Supplier_Order_Contract_Reference value
     * @return \StructType\Supplier_ContractObjectType|null
     */
    public function getSupplier_Order_Contract_Reference()
    {
        return $this->Supplier_Order_Contract_Reference;
    }
    /**
     * Set Supplier_Order_Contract_Reference value
     * @param \StructType\Supplier_ContractObjectType $supplier_Order_Contract_Reference
     * @return \StructType\Supplier_Order_ContractType
     */
    public function setSupplier_Order_Contract_Reference(\StructType\Supplier_ContractObjectType $supplier_Order_Contract_Reference = null)
    {
        $this->Supplier_Order_Contract_Reference = $supplier_Order_Contract_Reference;
        return $this;
    }
    /**
     * Get Supplier_Order_Contract_Data value
     * @return \StructType\Supplier_Order_Contract_Data_for_Put_and_GetType|null
     */
    public function getSupplier_Order_Contract_Data()
    {
        return $this->Supplier_Order_Contract_Data;
    }
    /**
     * Set Supplier_Order_Contract_Data value
     * @param \StructType\Supplier_Order_Contract_Data_for_Put_and_GetType $supplier_Order_Contract_Data
     * @return \StructType\Supplier_Order_ContractType
     */
    public function setSupplier_Order_Contract_Data(\StructType\Supplier_Order_Contract_Data_for_Put_and_GetType $supplier_Order_Contract_Data = null)
    {
        $this->Supplier_Order_Contract_Data = $supplier_Order_Contract_Data;
        return $this;
    }
}
