<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Update_Asset_Book_Configuration_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Update_Asset_Book_Configuration_ResponseType extends AbstractStructBase
{
    /**
     * The Update_Asset_Depreciation_Schedule_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Asset Depreciation Schedule
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Update_Asset_Depreciation_Schedule_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Update_Asset_Book_Configuration_ResponseType
     * @uses Update_Asset_Book_Configuration_ResponseType::setUpdate_Asset_Depreciation_Schedule_Reference()
     * @uses Update_Asset_Book_Configuration_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $update_Asset_Depreciation_Schedule_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $update_Asset_Depreciation_Schedule_Reference = null, $version = null)
    {
        $this
            ->setUpdate_Asset_Depreciation_Schedule_Reference($update_Asset_Depreciation_Schedule_Reference)
            ->setVersion($version);
    }
    /**
     * Get Update_Asset_Depreciation_Schedule_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getUpdate_Asset_Depreciation_Schedule_Reference()
    {
        return $this->Update_Asset_Depreciation_Schedule_Reference;
    }
    /**
     * Set Update_Asset_Depreciation_Schedule_Reference value
     * @param \StructType\Unique_IdentifierObjectType $update_Asset_Depreciation_Schedule_Reference
     * @return \StructType\Update_Asset_Book_Configuration_ResponseType
     */
    public function setUpdate_Asset_Depreciation_Schedule_Reference(\StructType\Unique_IdentifierObjectType $update_Asset_Depreciation_Schedule_Reference = null)
    {
        $this->Update_Asset_Depreciation_Schedule_Reference = $update_Asset_Depreciation_Schedule_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Update_Asset_Book_Configuration_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
