<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Worker_Travel_Profile_Header__HV__RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: The Web Service is set to Add Only; but the Worker Travel Profile already exists. | Travel Profiles Header Request.
 * @subpackage Structs
 */
class Worker_Travel_Profile_Header__HV__RequestType extends AbstractStructBase
{
    /**
     * The Worker_Travel_Profile_Listing_File_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Worker Travel Profile Listing File for update only purposes.
     * - minOccurs: 0
     * @var \StructType\Worker_Travel_Profile_Listing_FileObjectType
     */
    public $Worker_Travel_Profile_Listing_File_Reference;
    /**
     * The Worker_Travel_Profile_Listing_File_Data
     * Meta information extracted from the WSDL
     * - documentation: Worker Travel Profile Listing File Data
     * @var \StructType\Worker_Travel_Profile_Listing_File__HV__DataType
     */
    public $Worker_Travel_Profile_Listing_File_Data;
    /**
     * The Add_Only
     * Meta information extracted from the WSDL
     * - documentation: Add Only Flag. Indicates that the service is an add only, not an update.
     * @var bool
     */
    public $Add_Only;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Worker_Travel_Profile_Header__HV__RequestType
     * @uses Worker_Travel_Profile_Header__HV__RequestType::setWorker_Travel_Profile_Listing_File_Reference()
     * @uses Worker_Travel_Profile_Header__HV__RequestType::setWorker_Travel_Profile_Listing_File_Data()
     * @uses Worker_Travel_Profile_Header__HV__RequestType::setAdd_Only()
     * @uses Worker_Travel_Profile_Header__HV__RequestType::setVersion()
     * @param \StructType\Worker_Travel_Profile_Listing_FileObjectType $worker_Travel_Profile_Listing_File_Reference
     * @param \StructType\Worker_Travel_Profile_Listing_File__HV__DataType $worker_Travel_Profile_Listing_File_Data
     * @param bool $add_Only
     * @param string $version
     */
    public function __construct(\StructType\Worker_Travel_Profile_Listing_FileObjectType $worker_Travel_Profile_Listing_File_Reference = null, \StructType\Worker_Travel_Profile_Listing_File__HV__DataType $worker_Travel_Profile_Listing_File_Data = null, $add_Only = null, $version = null)
    {
        $this
            ->setWorker_Travel_Profile_Listing_File_Reference($worker_Travel_Profile_Listing_File_Reference)
            ->setWorker_Travel_Profile_Listing_File_Data($worker_Travel_Profile_Listing_File_Data)
            ->setAdd_Only($add_Only)
            ->setVersion($version);
    }
    /**
     * Get Worker_Travel_Profile_Listing_File_Reference value
     * @return \StructType\Worker_Travel_Profile_Listing_FileObjectType|null
     */
    public function getWorker_Travel_Profile_Listing_File_Reference()
    {
        return $this->Worker_Travel_Profile_Listing_File_Reference;
    }
    /**
     * Set Worker_Travel_Profile_Listing_File_Reference value
     * @param \StructType\Worker_Travel_Profile_Listing_FileObjectType $worker_Travel_Profile_Listing_File_Reference
     * @return \StructType\Worker_Travel_Profile_Header__HV__RequestType
     */
    public function setWorker_Travel_Profile_Listing_File_Reference(\StructType\Worker_Travel_Profile_Listing_FileObjectType $worker_Travel_Profile_Listing_File_Reference = null)
    {
        $this->Worker_Travel_Profile_Listing_File_Reference = $worker_Travel_Profile_Listing_File_Reference;
        return $this;
    }
    /**
     * Get Worker_Travel_Profile_Listing_File_Data value
     * @return \StructType\Worker_Travel_Profile_Listing_File__HV__DataType|null
     */
    public function getWorker_Travel_Profile_Listing_File_Data()
    {
        return $this->Worker_Travel_Profile_Listing_File_Data;
    }
    /**
     * Set Worker_Travel_Profile_Listing_File_Data value
     * @param \StructType\Worker_Travel_Profile_Listing_File__HV__DataType $worker_Travel_Profile_Listing_File_Data
     * @return \StructType\Worker_Travel_Profile_Header__HV__RequestType
     */
    public function setWorker_Travel_Profile_Listing_File_Data(\StructType\Worker_Travel_Profile_Listing_File__HV__DataType $worker_Travel_Profile_Listing_File_Data = null)
    {
        $this->Worker_Travel_Profile_Listing_File_Data = $worker_Travel_Profile_Listing_File_Data;
        return $this;
    }
    /**
     * Get Add_Only value
     * @return bool|null
     */
    public function getAdd_Only()
    {
        return $this->Add_Only;
    }
    /**
     * Set Add_Only value
     * @param bool $add_Only
     * @return \StructType\Worker_Travel_Profile_Header__HV__RequestType
     */
    public function setAdd_Only($add_Only = null)
    {
        // validation for constraint: boolean
        if (!is_null($add_Only) && !is_bool($add_Only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($add_Only, true), gettype($add_Only)), __LINE__);
        }
        $this->Add_Only = $add_Only;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Worker_Travel_Profile_Header__HV__RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
